input:not([type=checkbox]):not([type=radio]),
textarea,
select {
    -webkit-appearance: none;
    -moz-appearance: none;
    appearance: none;
}

input, textarea {
    outline: none;
    &:focus:required:invalid { border-color: red }
    &:required:valid { border-color: green }
}

:active, :hover, :focus {
    outline: 0 !important;
    outline-offset: 0 !important;
}

option::selection {background: #ccc;}
option::-moz-selection {background: #ccc;}
option::-webkit-selection {background: #ccc; color:#fff;}

input[type='number'] {
    -moz-appearance: textfield;
}


input[type="number"]::-webkit-outer-spin-button,
input[type="number"]::-webkit-inner-spin-button {
    display: none;
}


.field {
    width: 100%;
    display: block;
    font-weight: 400;
    position: relative;
    background: transparent;
    $input-selector: "input[type=text], input[type=email], input[type=number], input[type=password], textarea";

    #{$input-selector} {
        margin: 0;
        width: 100%;
        height: rem(32);
        outline: none;
        color: var(--gray-80);
        box-shadow: none;
        font-weight: 400;
        font-size: rem(13);
        line-height: rem(16);
        border-radius: rem(4);
        padding: rem(7) rem(14);
        background: #F8F8F8;
        display: block;
        vertical-align: middle;
        border: rem(1) solid var(--gray-10);
        transition: var(--transition-time);

        &::placeholder {
            color: var(--gray-40);
        }

        &::-ms-clear {
            display: none;
            width: 0;
            height: 0;
        }

        &:focus,
        &:active {
            outline: none;
            border-color: var(--gray-20);
            transition: var(--transition-time);

            &::placeholder {
                color:transparent;
            }
        }
    }

    textarea {
        height: auto;
        resize: vertical;
        min-height: 100%;
    }

    &__icon {
        fill: #5b3d38;
        font-size: 0;
        line-height: 0;
        top: calc(50% - 0.75rem);
        left: rem(16);
        height: rem(24);
        position: absolute;
        display: inline-block;
    }

    &__error {
        display: none;
        color: var(--red);
        font-size: rem(12);
        line-height: rem(14);
        margin-top: rem(4);
    }

    &--icon {

        #{$input-selector} {
            padding-left: rem(48);
        }
    }

    &--phone {

        #{$input-selector} {
            padding-left: rem(80);
        }
    }

    &--sm {

        #{$input-selector} {
            height: rem(32);
            font-size: rem(12);
            line-height: rem(20);
            padding: rem(5) rem(12);
        }
    }

    &.invalid {


        #{$input-selector} {
            border-color: var(--red) !important;
        }

        .field__error {
            display: block;
        }
    }
}

.range-field {
    display: block;
    font-weight: 400;
    position: relative;
    $input-selector: "input[type=text], input[type=email], input[type=password], input[type=number]";

    &__value {
        display: block;
        width: 100%;
        margin: 0;
        height: rem(32);
        outline: none;
        color: var(--gray-80);
        box-shadow: none;
        font-weight: 400;
        font-size: rem(12);
        line-height: rem(20);
        border-radius: rem(4);
        padding: rem(5) rem(8) rem(5) rem(8);
        background: #F8F8F8;
        vertical-align: middle;
        border: rem(1) solid var(--gray-10);
        transition: background-color var(--transition-time);

        &::placeholder {
            color: var(--gray-40);
            transition: var(--transition-time);
        }

        &::-ms-clear {
            display: none;
            width: 0;
            height: 0;
        }

        &:focus,
        &:active {
            outline: none;
            background: white;
            border-color: var(--blue);
            transition: background-color var(--transition-time);

            &::placeholder {
                color: var(--gray-20);
                transition: var(--transition-time);
            }
        }

        &:focus {
            padding-left: rem(12);

            &+ .range-field__label {
                //opacity: 0;
                //visibility: hidden;
            }
        }
    }

    &__label {
        top: 0;
        left: 0;
        z-index: 5;
        padding-left: rem(8);
        height: rem(36);
        font-weight: 400;
        font-size: rem(13);
        line-height: rem(20);
        position: absolute;
        //display: flex;
        //align-items: center;
        color: var(--gray-80);
        display: none !important;
    }

    &.filled {

        .range-field__value {
            background-color: white;
            border-color: var(--blue);
        }
    }
}

.form-range {
    display: grid;
    grid-column-gap: rem(4);
    grid-template-columns: 1fr 1fr;

    &.focus {

        .range-field__value {
            background: white;
            border-color: var(--blue);
        }
    }
}

textarea {
    overflow: hidden;
}
